/*
 * RCS info: $Source: /export/work/usr/CVS_DB/FP-Fixer/src/lib/fpfix64/fixed.h,v $
 *           $Revision: 1.1.1.1 $
 *           $Date: 2008/11/27 07:24:47 $
 *           $Author: ono $
 *           $Log: fixed.h,v $
 *           Revision 1.1.1.1  2008/11/27 07:24:47  ono
 *           first cvs modules.
 *
 * Copyright (c) 2008 ISHIZUE Design Automation Corp.
 */

/****************************************************************************************/
//FileName : fixed.h
//Name : K.Tsuchiya
//Copyright (C) 2004 - 2008 by ISHIZUE Design Automation Corp. All Right Reserved.
//Date :2006/2/17
//
//...These are library of fixed point for FP-Fixer.This library fixes fixed point
//   with C-language double type.
// exm.) unsigned fixed point
//     f=__ufixedBitSlice(f,8,16,FIXED_SAT,FIXED_TRN);
//
/*****************************************************************************************/
#ifndef FIXED_HEADER
#define FIXED_HEADER
//definition consts-----------------------------------------------------------------------
#define FIXED_ERROR -1

//#define __FIXED_USE64
#ifdef __FIXED_USE64
#define FIXED_BASEBITSIZE 64
#else
#define FIXED_BASEBITSIZE 32
#endif

#define FIXED_NON -1
//specification signed or unsigned.
enum _fixedSign{
  FIXED_SIGN_NON,
  FIXED_SIGNED,   //signed
  FIXED_UNSIGNED, //unsigned
  fixedSignSize
};
//quantization
enum _fixedRnd{
  FIXED_RND,  //round (half-adjust)
  FIXED_TRN,  //this mode always towards minus(default).
  fixedRndSize
};
//overflow
enum _fixedOvf{
  FIXED_SAT,  //saturation(this assign '1' in all bits).
  FIXED_WRAP,  //wrapping(default).
  fixedOvfSize
};
//function prototype----------------------------------------------------------------------

#ifdef __FIXED_USE64
//unsigned int bitslice
extern long long int __uintBitSlice(long long int fi, int bitsize, int ovf);
//unsigned int bitslice
extern long long int __intBitSlice(long long int fi, int bitsize, int ovf);
#else
//unsigned int bitslice
extern unsigned int __uintBitSlice(unsigned int fi, int bitsize, int ovf);
//unsigned int bitslice
extern int __intBitSlice(int fi, int bitsize, int ovf);
#endif
#define __sintBitSlice __intBitSlice

//signed fixed point model.
extern double __fixedBitSlice(double fi, int isize, int fsize, int ovf, int rnd);
//unsigned fixed point model.
extern double __ufixedBitSlice(double fi, int isize, int fsize, int ovf, int rnd);
//this is macro to fixedBitSlice.
#define __sfixedBitSlice __fixedBitSlice


//getting lsb from fsize.
extern double __fixedLsb(double fi, int fsize, int lsb);
//scaling .
extern double __fixedScale(double fi, int fsize, int scaleSize, int rnd);

/*checking 0 division*/
extern double __check0div(double fi);

//Global variavle-------------------------------------------------------------------------
extern int fixedOvflg;//overflow flg(true 0)
#endif
