/*
 * RCS info: $Source: /export/work/usr/CVS_DB/FP-Fixer/src/lib/fpfsim/fpfsim_ope.h,v $
 *           $Revision: 1.5 $
 *           $Date: 2009/06/25 11:19:00 $
 *           $Author: haru $
 *           $Log: fpfsim_ope.h,v $
 *           Revision 1.5  2009/06/25 11:19:00  haru
 *
 *           Grouping simulation
 *
 *           Revision 1.4  2009/03/31 01:05:01  haru
 *
 *           Chg. mul calc
 *
 *           Revision 1.3  2009/03/19 01:54:04  haru
 *
 *           090319
 *
 *           Revision 1.2  2009/03/03 10:00:40  haru
 *
 *           Chg. mul
 *           Add. math floor, ceil
 *           Chg. (1 << f_width) -> (1U << f_width)
 *
 *           Revision 1.1  2009/02/23 05:13:50  haru
 *
 *           new version
 *
 *           Revision 1.2  2008/11/28 07:25:48  haru
 *           first cvs modules.
 *
 * Copyright (c) 2009 ISHIZUE Design Automation Corp.
 */

/*============================================================================
 * 
 * ԡ
 * ե̾fpf_fxop.h
 *   ӥåȲϡʥߥ졼˥ڥ졼С
 *==========================================================================*/

#ifndef _FPFFIXED_FXOP_H
#define _FPFFIXED_FXOP_H


//
// û A + A
//

// û fpf_Fixed + A
template <class TYPE>
fpf_Fixed operator + (fpf_Fixed &left, TYPE val)
{
    fpf_Fixed result;
    result.copy( left );
    result.p_flag = FPF_P_FLAG_WAIT;
    result.i_flag = 1;
    result.i_width = __BASE_BIT_SIZE64 - left.f_width;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result.fval = left.fval + val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result.assignDoubleData( tmp + val );
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result.assignDoubleData( tmp + val );
        }
    }
    return result;
}

// û etc + fpf_Fixed
template <class TYPE>
fpf_Fixed operator + (TYPE val, fpf_Fixed &right)
{
    fpf_Fixed result;
    result.copy( right );
    result.p_flag = FPF_P_FLAG_WAIT;
    result.i_flag = 1;
    result.i_width = __BASE_BIT_SIZE64 - right.f_width;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result.fval = val + right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result.assignDoubleData( val + tmp );
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result.assignDoubleData( val + tmp );
        }
    }
    return result;
}

// û fpf_UFixed + etc
template <class TYPE>
fpf_UFixed operator + (fpf_UFixed &left, TYPE val)

{
    fpf_UFixed result;
    result.copy( left );
    result.p_flag = FPF_P_FLAG_WAIT;
    result.i_flag = 1;
    result.i_width = __BASE_BIT_SIZE64 - left.f_width;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result.fval = left.fval + val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result.assignDoubleData( tmp + val );
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result.assignDoubleData( tmp + val );
        }
    }
    return result;
}

// û etc + fpf_UFixed
template <class TYPE>
fpf_UFixed operator + (TYPE val, fpf_UFixed &right)
{
    fpf_UFixed result;
    result.copy( right );
    result.p_flag = FPF_P_FLAG_WAIT;
    result.i_flag = 1;
    result.i_width = __BASE_BIT_SIZE64 - right.f_width;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result.fval = val + right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result.assignDoubleData( val + tmp );
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result.assignDoubleData( val + tmp );
        }
    }
    return result;
}

// û fpf_Int + double
template <class TYPE>
double operator + (fpf_Int &left, double val)
{
    double result;

    if( left.i_flag == 0 ){
        result = left.ival + val;
    } else {
        result = left.ilval + val;
    }
    return result;
}

// û fpf_Int + A
template <class TYPE>
long long operator + (fpf_Int &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        result = left.ival + val;
    } else {
        result = left.ilval + val;
    }
    return result;
}

// û double + fpf_Int
template <class TYPE>
double operator + (double val, fpf_Int &right)
{
    double result;

    if( right.i_flag == 0 ){
        result = val + right.ival;
    } else {
        result = val + right.ilval;
    }
    return result;
}

// û A + fpf_Int
template <class TYPE>
long long operator + (TYPE val, fpf_Int &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = val + right.ival;
    } else {
        result = val + right.ilval;
    }
    return result;
}

// û fpf_UInt + double
template <class TYPE>
double operator + (fpf_UInt &left, double val)
{
    double result;

    if( left.i_flag == 0 ){
        result = left.ival + val;
    } else {
        result = left.ilval + val;
    }
    return result;
}

// û fpf_UInt + A
template <class TYPE>
long long operator + (fpf_UInt &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        result = left.ival + val;
    } else {
        result = left.ilval + val;
    }
    return result;
}

// û double + fpf_UInt
template <class TYPE>
double operator + (double val, fpf_UInt &right)
{
    double result;

    if( right.i_flag == 0 ){
        result = val + right.ival;
    } else {
        result = val + right.ilval;
    }
    return result;
}

// û A + fpf_UInt
template <class TYPE>
long long operator + (TYPE val, fpf_UInt &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = val + right.ival;
    } else {
        result = val + right.ilval;
    }
    return result;
}

//
//  A - A
//
//  fpf_Fixed - A
template <class TYPE>
fpf_Fixed operator - (fpf_Fixed &left, TYPE val)
{
    fpf_Fixed result;
    result.copy( left );
    result.p_flag = FPF_P_FLAG_WAIT;
    result.i_flag = 1;
    result.i_width = __BASE_BIT_SIZE64 - left.f_width;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result.fval = left.fval - val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result.assignDoubleData( tmp - val );
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result.assignDoubleData( tmp - val );
        }
    }
    return result;
}

//  etc - fpf_Fixed
template <class TYPE>
fpf_Fixed operator - (TYPE val, fpf_Fixed &right)
{
    fpf_Fixed result;
    result.copy( right );
    result.p_flag = FPF_P_FLAG_WAIT;
    result.i_flag = 1;
    result.i_width = __BASE_BIT_SIZE64 - right.f_width;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result.fval = val - right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result.assignDoubleData( val - tmp );
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result.assignDoubleData( val - tmp );
        }
    }
    return result;
}

//  fpf_UFixed - etc
template <class TYPE>
fpf_UFixed operator - (fpf_UFixed &left, TYPE val)

{
    fpf_UFixed result;
    result.copy( left );
    result.p_flag = FPF_P_FLAG_WAIT;
    result.i_flag = 1;
    result.i_width = __BASE_BIT_SIZE64 - left.f_width;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result.fval = left.fval - val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result.assignDoubleData( tmp - val );
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result.assignDoubleData( tmp - val );
        }
    }
    return result;
}

//  etc - fpf_UFixed
template <class TYPE>
fpf_UFixed operator - (TYPE val, fpf_UFixed &right)
{
    fpf_UFixed result;
    result.copy( right );
    result.p_flag = FPF_P_FLAG_WAIT;
    result.i_flag = 1;
    result.i_width = __BASE_BIT_SIZE64 - right.f_width;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result.fval = val - right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result.assignDoubleData( val - tmp );
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result.assignDoubleData( val - tmp );
        }
    }
    return result;
}

//  fpf_Int - double
template <class TYPE>
double operator - (fpf_Int &left, double val)
{
    double result;

    if( left.i_flag == 0 ){
        result = left.ival - val;
    } else {
        result = left.ilval - val;
    }
    return result;
}

//  fpf_Int - A
template <class TYPE>
long long operator - (fpf_Int &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        result = left.ival - val;
    } else {
        result = left.ilval - val;
    }
    return result;
}

//  double - fpf_Int
template <class TYPE>
double operator - (double val, fpf_Int &right)
{
    double result;

    if( right.i_flag == 0 ){
        result = val - right.ival;
    } else {
        result = val - right.ilval;
    }
    return result;
}

//  A - fpf_Int
template <class TYPE>
long long operator - (TYPE val, fpf_Int &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = val - right.ival;
    } else {
        result = val - right.ilval;
    }
    return result;
}

//  fpf_UInt - double
template <class TYPE>
double operator - (fpf_UInt &left, double val)
{
    double result;

    if( left.i_flag == 0 ){
        result = left.ival - val;
    } else {
        result = left.ilval - val;
    }
    return result;
}

//  fpf_UInt - A
template <class TYPE>
long long operator - (fpf_UInt &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        result = left.ival - val;
    } else {
        result = left.ilval - val;
    }
    return result;
}

//  double - fpf_UInt
template <class TYPE>
double operator - (double val, fpf_UInt &right)
{
    double result;

    if( right.i_flag == 0 ){
        result = val - right.ival;
    } else {
        result = val - right.ilval;
    }
    return result;
}

//  A - fpf_UInt
template <class TYPE>
long long operator - (TYPE val, fpf_UInt &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = val - right.ival;
    } else {
        result = val - right.ilval;
    }
    return result;
}

//
// 軻 A * A
//
// 軻 fpf_Fixed * A
template <class TYPE>
fpf_Fixed operator * (fpf_Fixed &left, TYPE val)
{
    fpf_Fixed result;
    result.copy( left );
    result.p_flag = FPF_P_FLAG_WAIT;
    result.i_flag = 1;
    result.i_width = __BASE_BIT_SIZE64 - left.f_width;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result.fval = left.fval * val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result.assignDoubleData( tmp * val );
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result.assignDoubleData( tmp * val );
        }
    }
    return result;
}

// 軻 etc * fpf_Fixed
template <class TYPE>
fpf_Fixed operator * (TYPE val, fpf_Fixed &right)
{
    fpf_Fixed result;
    result.copy( right );
    result.p_flag = FPF_P_FLAG_WAIT;
    result.i_flag = 1;
    result.i_width = __BASE_BIT_SIZE64 - right.f_width;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result.fval = val * right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result.assignDoubleData( val * tmp );
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result.assignDoubleData( val * tmp );
        }
    }
    return result;
}

// 軻 fpf_UFixed * etc
template <class TYPE>
fpf_UFixed operator * (fpf_UFixed &left, TYPE val)
{
    fpf_UFixed result;
    result.copy( left );
    result.p_flag = FPF_P_FLAG_WAIT;
    result.i_flag = 1;
    result.i_width = __BASE_BIT_SIZE64 - left.f_width;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result.fval = left.fval * val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result.assignDoubleData( tmp * val );
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result.assignDoubleData( tmp * val );
        }
    }
    return result;
}

// 軻 etc * fpf_UFixed
template <class TYPE>
fpf_UFixed operator * (TYPE val, fpf_UFixed &right)
{
    fpf_UFixed result;
    result.copy( right );
    result.p_flag = FPF_P_FLAG_WAIT;
    result.i_flag = 1;
    result.i_width = __BASE_BIT_SIZE64 - right.f_width;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result.fval = val * right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result.assignDoubleData( val * tmp );
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result.assignDoubleData( val * tmp );
        }
    }
    return result;
}

// 軻 fpf_Int * double
template <class TYPE>
double operator * (fpf_Int &left, double val)
{
    double result;

    if( left.i_flag == 0 ){
        result = left.ival * val;
    } else {
        result = left.ilval * val;
    }
    return result;
}

// 軻 fpf_Int * A
template <class TYPE>
long long operator * (fpf_Int &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        result = left.ival * val;
    } else {
        result = left.ilval * val;
    }
    return result;
}

// 軻 dpuble * fpf_Int
template <class TYPE>
double operator * (double val, fpf_Int &right)
{
    double result;

    if( right.i_flag == 0 ){
        result = val * right.ival;
    } else {
        result = val * right.ilval;
    }
    return result;
}

// 軻 A * fpf_Int
template <class TYPE>
long long operator * (TYPE val, fpf_Int &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = val * right.ival;
    } else {
        result = val * right.ilval;
    }
    return result;
}

// 軻 fpf_UInt * double
template <class TYPE>
double operator * (fpf_UInt &left, double val)
{
    double result;

    if( left.i_flag == 0 ){
        result = left.ival * val;
    } else {
        result = left.ilval * val;
    }
    return result;
}

// 軻 fpf_UInt * A
template <class TYPE>
long long operator * (fpf_UInt &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        result = left.ival * val;
    } else {
        result = left.ilval * val;
    }
    return result;
}

// 軻 double * fpf_UInt
template <class TYPE>
double operator * (double val, fpf_UInt &right)
{
    double result;

    if( right.i_flag == 0 ){
        result = val * right.ival;
    } else {
        result = val * right.ilval;
    }
    return result;
}

// 軻 A * fpf_UInt
template <class TYPE>
long long operator * (TYPE val, fpf_UInt &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = val * right.ival;
    } else {
        result = val * right.ilval;
    }
    return result;
}

//
//  A / A
//

//  LEFT
template <class RET_TYPE, class L_TYPE, class R_TYPE>
void _fpfsim_DivLeftT( RET_TYPE *result,
        int l_sgnd, int l_type, L_TYPE l_val, R_TYPE r_val )
{
    if( r_val == 0 ){
        return;
    }

    switch( l_type ){
    case FPFSIM_CHAR :
        if( l_sgnd == 1 ){
            unsigned char l_tmp = (unsigned char)l_val;
            *result = (RET_TYPE)(l_tmp / r_val);
        } else {
            char l_tmp = (char)l_val;
            *result = (RET_TYPE)(l_tmp / r_val);
        }
        break;
    case FPFSIM_SHORT :
        if( l_sgnd == 1 ){
            unsigned short l_tmp = (unsigned short)l_val;
            *result = (RET_TYPE)(l_tmp / r_val);
        } else {
            short l_tmp = (short)l_val;
            *result = (RET_TYPE)(l_tmp / r_val);
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            *result = (RET_TYPE)(l_tmp / r_val);
        } else {
            int l_tmp = (int)l_val;
            *result = (RET_TYPE)(l_tmp / r_val);
        }
        break;
    case FPFSIM_LONGLONG :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            *result = (RET_TYPE)(l_tmp / r_val);
        } else {
            long long l_tmp = (long long)l_val;
            *result = (RET_TYPE)(l_tmp / r_val);
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double l_tmp = (double)l_val;
            *result = (RET_TYPE)(l_tmp / r_val);
        }
        break;
    default :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            *result = (RET_TYPE)(l_tmp / r_val);
        } else {
            int l_tmp = (int)l_val;
            *result = (RET_TYPE)(l_tmp / r_val);
        }
    }
}

//  RIGHT
template <class RET_TYPE, class L_TYPE, class R_TYPE>
void _fpfsim_DivRightT( RET_TYPE *result,
        L_TYPE l_val, int r_sgnd, int r_type, R_TYPE r_val )
{
    if( r_val == 0 ){   // 
        *result = 0;
        return;
    }

    switch( r_type ){
    case FPFSIM_CHAR :
        if( r_sgnd == 1 ){
            unsigned char r_tmp = (unsigned char)r_val;
            *result = (RET_TYPE)(l_val / r_tmp);
        } else {
            char r_tmp = (char)r_val;
            *result = (RET_TYPE)(l_val / r_tmp);
        }
        break;
    case FPFSIM_SHORT :
        if( r_sgnd == 1 ){
            unsigned short r_tmp = (unsigned short)r_val;
            *result = (RET_TYPE)(l_val / r_tmp);
        } else {
            short r_tmp = (short)r_val;
            *result = (RET_TYPE)(l_val / r_tmp);
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( r_sgnd == 1 ){
            unsigned int r_tmp = (unsigned int)r_val;
            *result = (RET_TYPE)(l_val / r_tmp);
        } else {
            int r_tmp = (int)r_val;
            *result = (RET_TYPE)(l_val / r_tmp);
        }
        break;
    case FPFSIM_LONGLONG :
        if( r_sgnd == 1 ){
            unsigned long long r_tmp = (unsigned long long)r_val;
            *result = (RET_TYPE)(l_val / r_tmp);
        } else {
            long long r_tmp = (long long)r_val;
            *result = (RET_TYPE)(l_val / r_tmp);
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double r_tmp = (double)r_val;
            *result = (RET_TYPE)(l_val / r_tmp);
        }
        break;
    default :
        if( r_sgnd == 1 ){
            unsigned int r_tmp = (unsigned int)r_val;
            *result = (RET_TYPE)(l_val / r_tmp);
        } else {
            char r_tmp = (int)r_val;
            *result = (RET_TYPE)(l_val / r_tmp);
        }
    }
}

//  ǧ
template <class RET_TYPE, class L_TYPE, class R_TYPE>
void _fpfsim_div( RET_TYPE *result,
        int l_sgnd, int l_type, L_TYPE l_val,
        int r_sgnd, int r_type, R_TYPE r_val )
{
    switch( l_type ){
    case FPFSIM_CHAR :
        if( l_sgnd == 1 ){
            unsigned char l_tmp = (unsigned char)l_val;
            _fpfsim_DivRightT( result, l_tmp, r_sgnd, r_type, r_val);
        } else {
            char l_tmp = (char)l_val;
            _fpfsim_DivRightT( result, l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_SHORT :
        if( l_sgnd == 1 ){
            unsigned short l_tmp = (unsigned short)l_val;
            _fpfsim_DivRightT( result, l_tmp, r_sgnd, r_type, r_val);
        } else {
            short l_tmp = (short)l_val;
            _fpfsim_DivRightT( result, l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            _fpfsim_DivRightT( result, l_tmp, r_sgnd, r_type, r_val);
        } else {
            int l_tmp = (int)l_val;
            _fpfsim_DivRightT( result, l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_LONGLONG :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            _fpfsim_DivRightT( result, l_tmp, r_sgnd, r_type, r_val);
        } else {
            long long l_tmp = (long long)l_val;
            _fpfsim_DivRightT( result, l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double l_tmp = (double)l_val;
            _fpfsim_DivRightT( result, l_tmp, r_sgnd, r_type, r_val );
        }
        break;
    default :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            _fpfsim_DivRightT( result, l_tmp, r_sgnd, r_type, r_val);
        } else {
            long long l_tmp = (long long)l_val;
            _fpfsim_DivRightT( result, l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    }
}

//  fpf_Fixed / A
template <class TYPE>
double operator / (fpf_Fixed &left, TYPE val)
{
    double result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval / val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result = tmp / val;
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result = tmp / val;
        }
    }
    return result;
}

//  etc / fpf_Fixed
template <class TYPE>
double operator / (TYPE val, fpf_Fixed &right)
{
    double result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val / right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result = val / tmp ;
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result = val / tmp ;
        }
    }
    return result;
}

//  fpf_UFixed / etc
template <class TYPE>
double operator / (fpf_UFixed &left, TYPE val)
{
    double result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval / val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result = tmp / val;
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result = tmp / val;
        }
    }
    return result;
}

//  etc / fpf_UFixed
template <class TYPE>
double operator / (TYPE val, fpf_UFixed &right)
{
    double result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val / right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result = val / tmp;
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result = val / tmp;
        }
    }
    return result;
}

//  fpf_Int / double
template <class TYPE>
double operator / (fpf_Int &left, double val)
{
    double result;

    if( left.i_flag == 0 ){
        result = left.ival / val;
    } else {
        result = left.ilval / val;
    }

    return result;
}

//  fpf_Int / A
template <class TYPE>
long long operator / (fpf_Int &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        _fpfsim_DivLeftT( &result, 0, left.type, left.ival, val );
    } else {
        _fpfsim_DivLeftT( &result, 0, left.type, left.ilval, val );
    }
    return result;
}

//  double / fpf_Int
template <class TYPE>
double operator / (double val, fpf_Int &right)
{
    double result;

    if( right.i_flag == 0 ){
        result = val / right.ival;
    } else {
        result = val / right.ilval;
    }
    return result;
}

//  A / fpf_Int
template <class TYPE>
long long operator / (TYPE val, fpf_Int &right)
{
    long long result;

    if( right.i_flag == 0 ){
//        result = val / right.ival;
        _fpfsim_DivRightT( &result, val, 0, right.type, right.ival );
    } else {
//        result = val / right.ilval;
        _fpfsim_DivRightT( &result, val, 0, right.type, right.ilval );
    }
    return result;
}

//  fpf_UInt / double
template <class TYPE>
double operator / (fpf_UInt &left, double val)
{
    double result;

    if( left.i_flag == 0 ){
        result = left.ival / val;
    } else {
        result = left.ilval / val;
    }
    return result;
}

//  fpf_UInt / A
template <class TYPE>
long long operator / (fpf_UInt &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
//        result = left.ival / val;
        _fpfsim_DivLeftT( &result, 1, left.type, left.ival, val );
    } else {
//        result = left.ilval / val;
        _fpfsim_DivLeftT( &result, 1, left.type, left.ilval, val );
    }
    return result;
}

//  A / fpf_UInt
template <class TYPE>
double operator / (double val, fpf_UInt &right)
{
    double result;

    if( right.i_flag == 0 ){
        result = val / right.ival;
    } else {
        result = val / right.ilval;
    }
    return result;
}

//  A / fpf_UInt
template <class TYPE>
long long operator / (TYPE val, fpf_UInt &right)
{
    long long result;

    if( right.i_flag == 0 ){
//        result = val / right.ival;
        _fpfsim_DivRightT( &result, val, 1, right.type, right.ival );
    } else {
//        result = val / right.ilval;
        _fpfsim_DivRightT( &result, val, 1, right.type, right.ilval );
    }
    return result;
}

//
// ; A % A
//

// ; LEFT
template <class L_TYPE, class R_TYPE>
long long _fpfsim_ModLeftT(
        int l_sgnd, int l_type, L_TYPE l_val, R_TYPE r_val )
{
    long long result = 0;

    switch( l_type ){
    case FPFSIM_CHAR :
        if( l_sgnd == 1 ){
            unsigned char l_tmp = (unsigned char)l_val;
            result = l_tmp % r_val;
        } else {
            char l_tmp = (char)l_val;
            result = l_tmp % r_val;
        }
        break;
    case FPFSIM_SHORT :
        if( l_sgnd == 1 ){
            unsigned short l_tmp = (unsigned short)l_val;
            result = l_tmp % r_val;
        } else {
            short l_tmp = (short)l_val;
            result = l_tmp % r_val;
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = l_tmp % r_val;
        } else {
            int l_tmp = (int)l_val;
            result = l_tmp % r_val;
        }
        break;
    case FPFSIM_LONGLONG :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = l_tmp % r_val;
        } else {
            long long l_tmp = (long long)l_val;
            result = l_tmp % r_val;
        }
        break;
#if(0) //
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        double l_tmp = (double)l_val;
        result = l_tmp % r_val;
        break;
#endif
    default :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = l_tmp % r_val;
        } else {
            int l_tmp = (int)l_val;
            result = l_tmp % r_val;
        }
    }
    return result;
}

// ; RIGHT
template <class L_TYPE, class R_TYPE>
long long _fpfsim_ModRightT(
        L_TYPE l_val, int r_sgnd, int r_type, R_TYPE r_val )
{
    long long result = 0;

    switch( r_type ){
    case FPFSIM_CHAR :
        if( r_sgnd == 1 ){
            unsigned char r_tmp = (unsigned char)r_val;
            result = l_val % r_tmp;
        } else {
            char r_tmp = (char)r_val;
            result = l_val % r_tmp;
        }
        break;
    case FPFSIM_SHORT :
        if( r_sgnd == 1 ){
            unsigned short r_tmp = (unsigned short)r_val;
            result = l_val % r_tmp;
        } else {
            short r_tmp = (short)r_val;
            result = l_val % r_tmp;
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( r_sgnd == 1 ){
            unsigned int r_tmp = (unsigned int)r_val;
            result = l_val % r_tmp;
        } else {
            int r_tmp = (int)r_val;
            result = l_val % r_tmp;
        }
        break;
    case FPFSIM_LONGLONG :
        if( r_sgnd == 1 ){
            unsigned long long r_tmp = (unsigned long long)r_val;
            result = l_val % r_tmp;
        } else {
            long long r_tmp = (long long)r_val;
            result = l_val % r_tmp;
        }
        break;
#if(0) //
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        double r_tmp = (double)r_val;
        result = l_val % r_tmp;
        break;
#endif
    default :
        if( r_sgnd == 1 ){
            unsigned int r_tmp = (unsigned int)r_val;
            result = l_val % r_tmp;
        } else {
            char r_tmp = (int)r_val;
            result = l_val % r_tmp;
        }
    }
    return result;
}

// ; Mod(%) ǧ
template <class L_TYPE, class R_TYPE>
long long _fpfsim_Mod(
        int l_sgnd, int l_type, L_TYPE l_val,
        int r_sgnd, int r_type, R_TYPE r_val )
{
    int result = 0;

    switch( l_type ){
    case FPFSIM_CHAR :
        if( l_sgnd == 1 ){
            unsigned char l_tmp = (unsigned char)l_val;
            result = _fpfsim_ModRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            char l_tmp = (char)l_val;
            result = _fpfsim_ModRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_SHORT :
        if( l_sgnd == 1 ){
            unsigned short l_tmp = (unsigned short)l_val;
            result = _fpfsim_ModRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            short l_tmp = (short)l_val;
            result = _fpfsim_ModRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = _fpfsim_ModRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            int l_tmp = (int)l_val;
            result = _fpfsim_ModRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_LONGLONG :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = _fpfsim_ModRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            long long l_tmp = (long long)l_val;
            result = _fpfsim_ModRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
#if(0)
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        double l_tmp = (double)l_val;
        result = _fpfsim_ModRightT( l_tmp, r_sgnd, r_type, r_val );
        break;
#endif
    default :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = _fpfsim_ModRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            long long l_tmp = (long long)l_val;
            result = _fpfsim_ModRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    }
    return result;
}

// ; fpf_Int % A
template <class TYPE>
long long operator % (fpf_Int &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
//        result = left.ival % val;
        result = _fpfsim_ModLeftT( 0, left.type, left.ival, val );
    } else {
//        result = left.ilval % val;
        result = _fpfsim_ModLeftT( 0, left.type, left.ilval, val );
    }
    return result;
}

// ; A % fpf_Int
template <class TYPE>
long long operator % (TYPE val, fpf_Int &right)
{
    long long result;

    if( right.i_flag == 0 ){
//        result = val % right.ival;
        result = _fpfsim_ModRightT( val, 0, right.type, right.ival );
    } else {
//        result = val % right.ilval;
        result = _fpfsim_ModRightT( val, 0, right.type, right.ilval );
    }
    return result;
}

// ; fpf_UInt % A
template <class TYPE>
long long operator % (fpf_UInt &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
//        result = left.ival % val;
        result = _fpfsim_ModLeftT( 1, left.type, left.ival, val );
    } else {
//        result = left.ilval % val;
        result = _fpfsim_ModLeftT( 1, left.type, left.ilval, val );
    }
    return result;
}

// ; A % fpf_UInt
template <class TYPE>
long long operator % (TYPE val, fpf_UInt &right)
{
    long long result;

    if( right.i_flag == 0 ){
//        result = val % right.ival;
        result = _fpfsim_ModRightT( val, 1, right.type, right.ival );
    } else {
//        result = val % right.ilval;
        result = _fpfsim_ModRightT( val, 1, right.type, right.ilval );
    }
    return result;
}

//
//  A < A
//

//  Les(<) LEFT
template <class L_TYPE, class R_TYPE>
int _fpfsim_LesLeftT(
            int l_sgnd, int l_type, L_TYPE l_val, R_TYPE r_val )
{
    int result = 0;

    switch( l_type ){
    case FPFSIM_CHAR :
        if( l_sgnd == 1 ){
            unsigned char l_tmp = (unsigned char)l_val;
            result = l_tmp < r_val;
        } else {
            char l_tmp = (char)l_val;
            result = l_tmp < r_val;
        }
        break;
    case FPFSIM_SHORT :
        if( l_sgnd == 1 ){
            unsigned short l_tmp = (unsigned short)l_val;
            result = l_tmp < r_val;
        } else {
            short l_tmp = (short)l_val;
            result = l_tmp < r_val;
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = l_tmp < r_val;
        } else {
            int l_tmp = (int)l_val;
            result = l_tmp < r_val;
        }
        break;
    case FPFSIM_LONGLONG :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = l_tmp < r_val;
        } else {
            long long l_tmp = (long long)l_val;
            result = l_tmp < r_val;
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double l_tmp = (double)l_val;
            result = l_tmp < r_val;
        }
        break;
    default :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = l_tmp < r_val;
        } else {
            int l_tmp = (int)l_val;
            result = l_tmp < r_val;
        }
    }
    return result;
}

//  Les(<) RIGHT
template <class L_TYPE, class R_TYPE>
int _fpfsim_LesRightT(
        L_TYPE l_val, int r_sgnd, int r_type, R_TYPE r_val )
{
    int result = 0;

    switch( r_type ){
    case FPFSIM_CHAR :
        if( r_sgnd == 1 ){
            unsigned char r_tmp = (unsigned char)r_val;
            result = l_val < r_tmp;
        } else {
            char r_tmp = (char)r_val;
            result = l_val < r_tmp;
        }
        break;
    case FPFSIM_SHORT :
        if( r_sgnd == 1 ){
            unsigned short r_tmp = (unsigned short)r_val;
            result = l_val < r_tmp;
        } else {
            short r_tmp = (short)r_val;
            result = l_val < r_tmp;
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( r_sgnd == 1 ){
            unsigned int r_tmp = (unsigned int)r_val;
            result = l_val < r_tmp;
        } else {
            int r_tmp = (int)r_val;
            result = l_val < r_tmp;
        }
        break;
    case FPFSIM_LONGLONG :
        if( r_sgnd == 1 ){
            unsigned long long r_tmp = (unsigned long long)r_val;
            result = l_val < r_tmp;
        } else {
            long long r_tmp = (long long)r_val;
            result = l_val < r_tmp;
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double r_tmp = (double)r_val;
            result = l_val < r_tmp;
        }
        break;
    default :
        if( r_sgnd == 1 ){
            unsigned int r_tmp = (unsigned int)r_val;
            result = l_val < r_tmp;
        } else {
            char r_tmp = (int)r_val;
            result = l_val < r_tmp;
        }
    }
    return result;
}

//  Les(<) ǧ
template <class L_TYPE, class R_TYPE>
int _fpfsim_Les(
        int l_sgnd, int l_type, L_TYPE l_val,
        int r_sgnd, int r_type, R_TYPE r_val )
{
    int result = 0;

    switch( l_type ){
    case FPFSIM_CHAR :
        if( l_sgnd == 1 ){
            unsigned char l_tmp = (unsigned char)l_val;
            result = _fpfsim_LesRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            char l_tmp = (char)l_val;
            result = _fpfsim_LesRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_SHORT :
        if( l_sgnd == 1 ){
            unsigned short l_tmp = (unsigned short)l_val;
            result = _fpfsim_LesRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            short l_tmp = (short)l_val;
            result = _fpfsim_LesRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = _fpfsim_LesRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            int l_tmp = (int)l_val;
            result = _fpfsim_LesRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_LONGLONG :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = _fpfsim_LesRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            long long l_tmp = (long long)l_val;
            result = _fpfsim_LesRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double l_tmp = (double)l_val;
            result = _fpfsim_LesRightT( l_tmp, r_sgnd, r_type, r_val );
        }
        break;
    default :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = _fpfsim_LesRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            long long l_tmp = (long long)l_val;
            result = _fpfsim_LesRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    }
    return result;
}


//  fpf_Fixed < A
template <class TYPE>
int operator < (fpf_Fixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval < val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result = tmp < val;
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result = tmp < val;
        }
    }
    return result;
}

//  etc < fpf_Fixed
template <class TYPE>
int operator < (TYPE val, fpf_Fixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val < right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result = val < tmp;
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result = val < tmp;
        }
    }
    return result;
}

//  fpf_UFixed < etc
template <class TYPE>
int operator < (fpf_UFixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval < val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result = tmp < val;
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result = tmp < val;
        }
    }
    return result;
}

//  etc < fpf_UFixed
template <class TYPE>
int operator < (TYPE val, fpf_UFixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val < right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result = val < tmp;
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result = val < tmp;
        }
    }
    return result;
}

//  fpf_Int < A
template <class TYPE>
int operator < (fpf_Int &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
//        result = left.ival < val;
        result = _fpfsim_LesLeftT( 0, left.type, left.ival, val );
    } else {
//        result = left.ilval < val;
        result = _fpfsim_LesLeftT(0, left.type, left.ilval, val );
    }
    return result;
}

//  A < fpf_Int
template <class TYPE>
int operator < (TYPE val, fpf_Int &right)
{
    int result;

    if( right.i_flag == 0 ){
//        result = val < right.ival;
        result = _fpfsim_LesRightT( val, 0, right.type, right.ival );
    } else {
//        result = val < right.ilval;
        result = _fpfsim_LesRightT( val, 0, right.type, right.ilval );
    }
    return result;
}

//  fpf_UInt < A
template <class TYPE>
int operator < (fpf_UInt &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
//        result = left.ival < val;
        result = _fpfsim_LesLeftT( 1, left.type, left.ival, val );
    } else {
//        result = left.ilval < val;
        result = _fpfsim_LesLeftT( 1, left.type, left.ilval, val );
    }
    return result;
}

//  A < fpf_UInt
template <class TYPE>
int operator < (TYPE val, fpf_UInt &right)
{
    int result;

    if( right.i_flag == 0 ){
//        result = val < right.ival;
        result = _fpfsim_LesRightT( val, 1, right.type, right.ival );
    } else {
//        result = val < right.ilval;
        result = _fpfsim_LesRightT( val, 1, right.type, right.ilval );
    }
    return result;
}

//
//  A <= A
//

//  LesEq(<=) LEFT
template <class L_TYPE, class R_TYPE>
int _fpfsim_LesEqLeftT(
        int l_sgnd, int l_type, L_TYPE l_val, R_TYPE r_val )
{
    int result = 0;

    switch( l_type ){
    case FPFSIM_CHAR :
        if( l_sgnd == 1 ){
            unsigned char l_tmp = (unsigned char)l_val;
            result = l_tmp <= r_val;
        } else {
            char l_tmp = (char)l_val;
            result = l_tmp <= r_val;
        }
        break;
    case FPFSIM_SHORT :
        if( l_sgnd == 1 ){
            unsigned short l_tmp = (unsigned short)l_val;
            result = l_tmp <= r_val;
        } else {
            short l_tmp = (short)l_val;
            result = l_tmp <= r_val;
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = l_tmp <= r_val;
        } else {
            int l_tmp = (int)l_val;
            result = l_tmp <= r_val;
        }
        break;
    case FPFSIM_LONGLONG :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = l_tmp <= r_val;
        } else {
            long long l_tmp = (long long)l_val;
            result = l_tmp <= r_val;
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double l_tmp = (double)l_val;
            result = l_tmp < r_val;
        }
        break;
    default :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = l_tmp <= r_val;
        } else {
            int l_tmp = (int)l_val;
            result = l_tmp <= r_val;
        }
    }
    return result;
}

//  LesEq(<=) RIGHT
template <class L_TYPE, class R_TYPE>
int _fpfsim_LesEqRightT(
        L_TYPE l_val, int r_sgnd, int r_type, R_TYPE r_val )
{
    int result = 0;

    switch( r_type ){
    case FPFSIM_CHAR :
        if( r_sgnd == 1 ){
            unsigned char r_tmp = (unsigned char)r_val;
            result = l_val <= r_tmp;
        } else {
            char r_tmp = (char)r_val;
            result = l_val <= r_tmp;
        }
        break;
    case FPFSIM_SHORT :
        if( r_sgnd == 1 ){
            unsigned short r_tmp = (unsigned short)r_val;
            result = l_val <= r_tmp;
        } else {
            short r_tmp = (short)r_val;
            result = l_val <= r_tmp;
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( r_sgnd == 1 ){
            unsigned int r_tmp = (unsigned int)r_val;
            result = l_val <= r_tmp;
        } else {
            int r_tmp = (int)r_val;
            result = l_val <= r_tmp;
        }
        break;
    case FPFSIM_LONGLONG :
        if( r_sgnd == 1 ){
            unsigned long long r_tmp = (unsigned long long)r_val;
            result = l_val <= r_tmp;
        } else {
            long long r_tmp = (long long)r_val;
            result = l_val <= r_tmp;
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double r_tmp = (double)r_val;
            result = l_val <= r_tmp;
        }
        break;
    default :
        if( r_sgnd == 1 ){
            unsigned int r_tmp = (unsigned int)r_val;
            result = l_val <= r_tmp;
        } else {
            char r_tmp = (int)r_val;
            result = l_val <= r_tmp;
        }
    }
    return result;
}

//  LesEq(<=) ǧ
template <class L_TYPE, class R_TYPE>
int _fpfsim_LesEq(
        int l_sgnd, int l_type, L_TYPE l_val,
        int r_sgnd, int r_type, R_TYPE r_val )
{
    int result = 0;

    switch( l_type ){
    case FPFSIM_CHAR :
        if( l_sgnd == 1 ){
            unsigned char l_tmp = (unsigned char)l_val;
            result = _fpfsim_LesEqRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            char l_tmp = (char)l_val;
            result = _fpfsim_LesEqRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_SHORT :
        if( l_sgnd == 1 ){
            unsigned short l_tmp = (unsigned short)l_val;
            result = _fpfsim_LesEqRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            short l_tmp = (short)l_val;
            result = _fpfsim_LesEqRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = _fpfsim_LesEqRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            int l_tmp = (int)l_val;
            result = _fpfsim_LesEqRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_LONGLONG :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = _fpfsim_LesEqRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            long long l_tmp = (long long)l_val;
            result = _fpfsim_LesEqRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double l_tmp = (double)l_val;
            result = _fpfsim_LesEqRightT( l_tmp, r_sgnd, r_type, r_val );
        }
        break;
    default :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = _fpfsim_LesEqRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            long long l_tmp = (long long)l_val;
            result = _fpfsim_LesEqRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    }
    return result;
}

//  fpf_Fixed <= A
template <class TYPE>
int operator <= (fpf_Fixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval <= val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result = tmp <= val;
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result = tmp <= val;
        }
    }
    return result;
}

//  etc <= fpf_Fixed
template <class TYPE>
int operator <= (TYPE val, fpf_Fixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val <= right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result = val <= tmp;
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result = val <= tmp;
        }
    }
    return result;
}

//  fpf_UFixed <= etc
template <class TYPE>
int operator <= (fpf_UFixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval <= val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result = tmp <= val;
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result = tmp <= val;
        }
    }
    return result;
}

//  etc <= fpf_UFixed
template <class TYPE>
int operator <= (TYPE val, fpf_UFixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val <= right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result = val <= tmp;
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result = val <= tmp;
        }
    }
    return result;
}

//  fpf_Int <= A
template <class TYPE>
int operator <= (fpf_Int &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
//        result = left.ival <= val;
        result = _fpfsim_LesEqLeftT( 0, left.type, left.ival, val );
    } else {
//        result = left.ilval <= val;
        result = _fpfsim_LesEqLeftT( 0, left.type, left.ilval, val );
    }
    return result;
}

//  A <= fpf_Int
template <class TYPE>
int operator <= (TYPE val, fpf_Int &right)
{
    int result;

    if( right.i_flag == 0 ){
//        result = val <= right.ival;
        result = _fpfsim_LesEqRightT( val, 0, right.type, right.ival );
    } else {
//        result = val <= right.ilval;
        result = _fpfsim_LesEqRightT( val, 0, right.type, right.ilval);
    }
    return result;
}

//  fpf_UInt <= A
template <class TYPE>
int operator <= (fpf_UInt &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
//        result = left.ival <= val;
        result = _fpfsim_LesEqLeftT( 1, left.type, left.ival, val );
    } else {
//        result = left.ilval <= val;
        result = _fpfsim_LesEqLeftT( 1, left.type, left.ilval, val );
    }
    return result;
}

//  A <= fpf_UInt
template <class TYPE>
int operator <= (TYPE val, fpf_UInt &right)
{
    int result;

    if( right.i_flag == 0 ){
//        result = val <= right.ival;
        result = _fpfsim_LesEqRightT( val, 1, right.type, right.ival );
    } else {
//        result = val <= right.ilval;
        result = _fpfsim_LesEqRightT( val, 1, right.type, right.ilval);
    }
    return result;
}


//
//  A > A
//

//  Gre(>) LEFT
template <class L_TYPE, class R_TYPE>
int _fpfsim_GreLeftT(
        int l_sgnd, int l_type, L_TYPE l_val, R_TYPE r_val )
{
    int result = 0;

    switch( l_type ){
    case FPFSIM_CHAR :
        if( l_sgnd == 1 ){
            unsigned char l_tmp = (unsigned char)l_val;
            result = l_tmp > r_val;
        } else {
            char l_tmp = (char)l_val;
            result = l_tmp > r_val;
        }
        break;
    case FPFSIM_SHORT :
        if( l_sgnd == 1 ){
            unsigned short l_tmp = (unsigned short)l_val;
            result = l_tmp > r_val;
        } else {
            short l_tmp = (short)l_val;
            result = l_tmp > r_val;
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = l_tmp > r_val;
        } else {
            int l_tmp = (int)l_val;
            result = l_tmp > r_val;
        }
        break;
    case FPFSIM_LONGLONG :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = l_tmp > r_val;
        } else {
            long long l_tmp = (long long)l_val;
            result = l_tmp > r_val;
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double l_tmp = (double)l_val;
            result = l_tmp > r_val;
        }
        break;
    default :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = l_tmp > r_val;
        } else {
            int l_tmp = (int)l_val;
            result = l_tmp > r_val;
        }
    }
    return result;
}

//  Gre(>) RIGHT
template <class L_TYPE, class R_TYPE>
int _fpfsim_GreRightT(
        L_TYPE l_val, int r_sgnd, int r_type, R_TYPE r_val )
{
    int result = 0;

    switch( r_type ){
    case FPFSIM_CHAR :
        if( r_sgnd == 1 ){
            unsigned char r_tmp = (unsigned char)r_val;
            result = l_val > r_tmp;
        } else {
            char r_tmp = (char)r_val;
            result = l_val > r_tmp;
        }
        break;
    case FPFSIM_SHORT :
        if( r_sgnd == 1 ){
            unsigned short r_tmp = (unsigned short)r_val;
            result = l_val > r_tmp;
        } else {
            short r_tmp = (short)r_val;
            result = l_val > r_tmp;
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( r_sgnd == 1 ){
            unsigned int r_tmp = (unsigned int)r_val;
            result = l_val > r_tmp;
        } else {
            int r_tmp = (int)r_val;
            result = l_val > r_tmp;
        }
        break;
    case FPFSIM_LONGLONG :
        if( r_sgnd == 1 ){
            unsigned long long r_tmp = (unsigned long long)r_val;
            result = l_val > r_tmp;
        } else {
            long long r_tmp = (long long)r_val;
            result = l_val > r_tmp;
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double r_tmp = (double)r_val;
            result = l_val > r_tmp;
        }
        break;
    default :
        if( r_sgnd == 1 ){
            unsigned int r_tmp = (unsigned int)r_val;
            result = l_val > r_tmp;
        } else {
            char r_tmp = (int)r_val;
            result = l_val > r_tmp;
        }
    }
    return result;
}

//  Gre(>) ǧ
template <class L_TYPE, class R_TYPE>
int _fpfsim_Gre(
        int l_sgnd, int l_type, L_TYPE l_val,
        int r_sgnd, int r_type, R_TYPE r_val )
{
    int result;

    switch( l_type ){
    case FPFSIM_CHAR :
        if( l_sgnd == 1 ){
            unsigned char l_tmp = (unsigned char)l_val;
            result = _fpfsim_GreRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            char l_tmp = (char)l_val;
            result = _fpfsim_GreRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_SHORT :
        if( l_sgnd == 1 ){
            unsigned short l_tmp = (unsigned short)l_val;
            result = _fpfsim_GreRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            short l_tmp = (short)l_val;
            result = _fpfsim_GreRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = _fpfsim_GreRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            int l_tmp = (int)l_val;
            result = _fpfsim_GreRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_LONGLONG :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = _fpfsim_GreRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            long long l_tmp = (long long)l_val;
            result = _fpfsim_GreRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double l_tmp = (double)l_val;
            result = _fpfsim_GreRightT( l_tmp, r_sgnd, r_type, r_val );
        }
        break;
    default :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = _fpfsim_GreRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            long long l_tmp = (long long)l_val;
            result = _fpfsim_GreRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    }
    return result;
}

//  fpf_Fixed > A
template <class TYPE>
int operator > (fpf_Fixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval > val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result = tmp > val;
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result = tmp > val;
        }
    }
    return result;
}

//  etc > fpf_Fixed
template <class TYPE>
int operator > (TYPE val, fpf_Fixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val > right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result = val > tmp;
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result = val > tmp;
        }
    }
    return result;
}

//  fpf_UFixed > etc
template <class TYPE>
int operator > (fpf_UFixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval > val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result = tmp > val;
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result = tmp > val;
        }
    }
    return result;
}

//  etc > fpf_UFixed
template <class TYPE>
int operator > (TYPE val, fpf_UFixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val > right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result = val > tmp;
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result = val > tmp;
        }
    }
    return result;
}

//  fpf_Int > A
template <class TYPE>
int operator > (fpf_Int &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
//        result = left.ival > val;
        result = _fpfsim_GreLeftT( 0, left.type, left.ival, val );
    } else {
//        result = left.ilval > val;
        result = _fpfsim_GreLeftT( 0, left.type, left.ilval, val );
    }
    return result;
}

//  A > fpf_Int
template <class TYPE>
int operator > (TYPE val, fpf_Int &right)
{
    int result;

    if( right.i_flag == 0 ){
//        result = val > right.ival;
        result = _fpfsim_GreRightT( val, 0, right.type, right.ival );
    } else {
//        result = val > right.ilval;
        result = _fpfsim_GreRightT( val, 0, right.type, right.ilval );
    }
    return result;
}

//  fpf_UInt > A
template <class TYPE>
int operator > (fpf_UInt &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
//        result = left.ival > val;
        result = _fpfsim_GreLeftT( 1, left.type, left.ival, val );
    } else {
//        result = left.ilval > val;
        result = _fpfsim_GreLeftT( 1, left.type, left.ilval, val );
    }
    return result;
}

//  A > fpf_UInt
template <class TYPE>
int operator > (TYPE val, fpf_UInt &right)
{
    int result;

    if( right.i_flag == 0 ){
//        result = val > right.ival;
        result = _fpfsim_GreRightT( val, 1, right.type, right.ival );
    } else {
//        result = val > right.ilval;
        result = _fpfsim_GreRightT( val, 1, right.type, right.ilval );
    }
    return result;
}

//
//  A >= A
//

//  GreEq(>=) LEFT
template <class L_TYPE, class R_TYPE>
int _fpfsim_GreEqLeftT(
        int l_sgnd, int l_type, L_TYPE l_val, R_TYPE r_val )
{
    int result = 0;

    switch( l_type ){
    case FPFSIM_CHAR :
        if( l_sgnd == 1 ){
            unsigned char l_tmp = (unsigned char)l_val;
            result = l_tmp >= r_val;
        } else {
            char l_tmp = (char)l_val;
            result = l_tmp >= r_val;
        }
        break;
    case FPFSIM_SHORT :
        if( l_sgnd == 1 ){
            unsigned short l_tmp = (unsigned short)l_val;
            result = l_tmp >= r_val;
        } else {
            short l_tmp = (short)l_val;
            result = l_tmp >= r_val;
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = l_tmp >= r_val;
        } else {
            int l_tmp = (int)l_val;
            result = l_tmp >= r_val;
        }
        break;
    case FPFSIM_LONGLONG :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = l_tmp >= r_val;
        } else {
            long long l_tmp = (long long)l_val;
            result = l_tmp >= r_val;
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double l_tmp = (double)l_val;
            result = l_tmp >= r_val;
        }
        break;
    default :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = l_tmp >= r_val;
        } else {
            int l_tmp = (int)l_val;
            result = l_tmp >= r_val;
        }
    }
    return result;
}

//  GreEq(>=) RIGHT
template <class L_TYPE, class R_TYPE>
int _fpfsim_GreEqRightT(
        L_TYPE l_val, int r_sgnd, int r_type, R_TYPE r_val )
{
    int result = 0;

    switch( r_type ){
    case FPFSIM_CHAR :
        if( r_sgnd == 1 ){
            unsigned char r_tmp = (unsigned char)r_val;
            result = l_val >= r_tmp;
        } else {
            char r_tmp = (char)r_val;
            result = l_val >= r_tmp;
        }
        break;
    case FPFSIM_SHORT :
        if( r_sgnd == 1 ){
            unsigned short r_tmp = (unsigned short)r_val;
            result = l_val >= r_tmp;
        } else {
            short r_tmp = (short)r_val;
            result = l_val >= r_tmp;
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( r_sgnd == 1 ){
            unsigned int r_tmp = (unsigned int)r_val;
            result = l_val >= r_tmp;
        } else {
            int r_tmp = (int)r_val;
            result = l_val >= r_tmp;
        }
        break;
    case FPFSIM_LONGLONG :
        if( r_sgnd == 1 ){
            unsigned long long r_tmp = (unsigned long long)r_val;
            result = l_val >= r_tmp;
        } else {
            long long r_tmp = (long long)r_val;
            result = l_val >= r_tmp;
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double r_tmp = (double)r_val;
            result = l_val >= r_tmp;
        }
        break;
    default :
        if( r_sgnd == 1 ){
            unsigned int r_tmp = (unsigned int)r_val;
            result = l_val >= r_tmp;
        } else {
            char r_tmp = (int)r_val;
            result = l_val >= r_tmp;
        }
    }
    return result;
}

//  GreEq(>=) ǧ
template <class L_TYPE, class R_TYPE>
int _fpfsim_GreEq(
        int l_sgnd, int l_type, L_TYPE l_val,
        int r_sgnd, int r_type, R_TYPE r_val )
{
    int result = 0;

    switch( l_type ){
    case FPFSIM_CHAR :
        if( l_sgnd == 1 ){
            unsigned char l_tmp = (unsigned char)l_val;
            result = _fpfsim_GreEqRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            char l_tmp = (char)l_val;
            result = _fpfsim_GreEqRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_SHORT :
        if( l_sgnd == 1 ){
            unsigned short l_tmp = (unsigned short)l_val;
            result = _fpfsim_GreEqRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            short l_tmp = (short)l_val;
            result = _fpfsim_GreEqRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_INT:
    case FPFSIM_LONG :
        if( l_sgnd == 1 ){
            unsigned int l_tmp = (unsigned int)l_val;
            result = _fpfsim_GreEqRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            int l_tmp = (int)l_val;
            result = _fpfsim_GreEqRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_LONGLONG :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = _fpfsim_GreEqRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            long long l_tmp = (long long)l_val;
            result = _fpfsim_GreEqRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    case FPFSIM_FLOAT :
    case FPFSIM_DOUBLE :
    case FPFSIM_LONGDOUBLE :
        {
            double l_tmp = (double)l_val;
            result = _fpfsim_GreEqRightT( l_tmp, r_sgnd, r_type, r_val );
        }
        break;
    default :
        if( l_sgnd == 1 ){
            unsigned long long l_tmp = (unsigned long long)l_val;
            result = _fpfsim_GreEqRightT( l_tmp, r_sgnd, r_type, r_val);
        } else {
            long long l_tmp = (long long)l_val;
            result = _fpfsim_GreEqRightT( l_tmp, r_sgnd, r_type, r_val);
        }
        break;
    }
    return result;
}


//  fpf_Fixed >= A
template <class TYPE>
int operator >= (fpf_Fixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval >= val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result = tmp >= val;
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result = tmp >= val;
        }
    }
    return result;
}

//  etc >= fpf_Fixed
template <class TYPE>
int operator >= (TYPE val, fpf_Fixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val >= right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result = val >= tmp;
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result = val >= tmp;
        }
    }
    return result;
}

//  fpf_UFixed >= etc
template <class TYPE>
int operator >= (fpf_UFixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval >= val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result = tmp >= val;
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result = tmp >= val;
        }
    }
    return result;
}

//  etc >= fpf_UFixed
template <class TYPE>
int operator >= (TYPE val, fpf_UFixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val >= right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result = val >= tmp;
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result = val >= tmp;
        }
    }
    return result;
}

//  fpf_Int >= A
template <class TYPE>
int operator >= (fpf_Int &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
//        result = left.ival >= val;
        result = _fpfsim_GreEqLeftT( 0, left.type, left.ival, val );
    } else {
//        result = left.ilval >= val;
        result = _fpfsim_GreEqLeftT( 0, left.type, left.ilval, val );
    }
    return result;
}

//  A >= fpf_Int
template <class TYPE>
int operator >= (TYPE val, fpf_Int &right)
{
    int result;

    if( right.i_flag == 0 ){
//        result = val >= right.ival;
        result = _fpfsim_GreEqRightT( val, 0, right.type, right.ival );
    } else {
//        result = val >= right.ilval;
        result = _fpfsim_GreEqRightT( val, 0, right.type, right.ilval);
    }
    return result;
}

//  fpf_UInt >= A
template <class TYPE>
int operator >= (fpf_UInt &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
//        result = left.ival >= val;
        result = _fpfsim_GreEqLeftT( 1, left.type, left.ival, val );
    } else {
//        result = left.ilval >= val;
        result = _fpfsim_GreEqLeftT( 1, left.type, left.ilval, val );
    }
    return result;
}

//  A >= fpf_UInt
template <class TYPE>
int operator >= (TYPE val, fpf_UInt &right)
{
    int result;

    if( right.i_flag == 0 ){
//        result = val >= right.ival;
        result = _fpfsim_GreEqRightT( val, 1, right.type, right.ival );
    } else {
//        result = val >= right.ilval;
        result = _fpfsim_GreEqRightT( val, 1, right.type, right.ilval);
    }
    return result;
}

//
//  A == A
//
//  fpf_Fixed == A
template <class TYPE>
int operator == (fpf_Fixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval == val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result = tmp == val;
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result = tmp == val;
        }
    }
    return result;
}

//  etc == fpf_Fixed
template <class TYPE>
int operator == (TYPE val, fpf_Fixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val == right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result = val == tmp;
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result = val == tmp;
        }
    }
    return result;
}

//  fpf_UFixed == etc
template <class TYPE>
int operator == (fpf_UFixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval == val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result = tmp == val;
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result = tmp == val;
        }
    }
    return result;
}

//  etc == fpf_UFixed
template <class TYPE>
int operator == (TYPE val, fpf_UFixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val == right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result = val == tmp;
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result = val == tmp;
        }
    }
    return result;
}

//  fpf_Int == A
template <class TYPE>
int operator == (fpf_Int &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
        result = left.ival == val;
    } else {
        result = left.ilval == val;
    }
    return result;
}

//  A == fpf_Int
template <class TYPE>
int operator == (TYPE val, fpf_Int &right)
{
    int result;

    if( right.i_flag == 0 ){
        result = val == right.ival;
    } else {
        result = val == right.ilval;
    }
    return result;
}

//  fpf_UInt == A
template <class TYPE>
int operator == (fpf_UInt &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
        result = left.ival == val;
    } else {
        result = left.ilval == val;
    }
    return result;
}

//  A == fpf_UInt
template <class TYPE>
int operator == (TYPE val, fpf_UInt &right)
{
    int result;

    if( right.i_flag == 0 ){
        result = val == right.ival;
    } else {
        result = val == right.ilval;
    }
    return result;
}

//
//  A != A
//
//  fpf_Fixed != A
template <class TYPE>
int operator != (fpf_Fixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval != val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result = tmp != val;
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result = tmp != val;
        }
    }
    return result;
}

//  etc != fpf_Fixed
template <class TYPE>
int operator != (TYPE val, fpf_Fixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val != right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result = val != tmp;
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result = val != tmp;
        }
    }
    return result;
}

//  fpf_UFixed != etc
template <class TYPE>
int operator != (fpf_UFixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval != val;
    } else {
        if( left.i_flag == 0 ){
            double tmp = (double)left.ival / (1U << left.f_width);
            result = tmp != val;
        } else {
            double tmp = (double)left.ilval / (1LLU << left.f_width);
            result = tmp != val;
        }
    }
    return result;
}

//  etc != fpf_UFixed
template <class TYPE>
int operator != (TYPE val, fpf_UFixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val != right.fval;
    } else {
        if( right.i_flag == 0 ){
            double tmp = (double)right.ival / (1U << right.f_width);
            result = val != tmp;
        } else {
            double tmp = (double)right.ilval / (1LLU << right.f_width);
            result = val != tmp;
        }
    }
    return result;
}

//  fpf_Int != A
template <class TYPE>
int operator != (fpf_Int &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
        result = left.ival != val;
    } else {
        result = left.ilval != val;
    }
    return result;
}

//  A != fpf_Int
template <class TYPE>
int operator != (TYPE val, fpf_Int &right)
{
    int result;

    if( right.i_flag == 0 ){
        result = val != right.ival;
    } else {
        result = val != right.ilval;
    }
    return result;
}

//  fpf_UInt != A
template <class TYPE>
int operator != (fpf_UInt &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
        result = left.ival != val;
    } else {
        result = left.ilval != val;
    }
    return result;
}

//  A != fpf_UInt
template <class TYPE>
int operator != (TYPE val, fpf_UInt &right)
{
    int result;

    if( right.i_flag == 0 ){
        result = val != right.ival;
    } else {
        result = val != right.ilval;
    }
    return result;
}

//
//  A && A
//
//  fpf_Fixed && A
template <class TYPE>
int operator && (fpf_Fixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval && val;
    } else {
        if( left.i_flag == 0 ){
            result = left.ival && val;
        } else {
            result = left.ilval && val;
        }
    }
    return result;
}

//  etc && fpf_Fixed
template <class TYPE>
int operator && (TYPE val, fpf_Fixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val && right.fval;
    } else {
        if( right.i_flag == 0 ){
            result = val && right.ival;
        } else {
            result = val && right.ilval;
        }
    }
    return result;
}

//  fpf_UFixed && etc
template <class TYPE>
int operator && (fpf_UFixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval && val;
    } else {
        if( left.i_flag == 0 ){
            result = left.ival && val;
        } else {
            result = left.ilval && val;
        }
    }
    return result;
}

//  etc && fpf_UFixed
template <class TYPE>
int operator && (TYPE val, fpf_UFixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val && right.fval;
    } else {
        if( right.i_flag == 0 ){
            result = val && right.ival;
        } else {
            result = val && right.ilval;
        }
    }
    return result;
}

//  fpf_Int && A
template <class TYPE>
int operator && (fpf_Int &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
        result = left.ival && val;
    } else {
        result = left.ilval && val;
    }
    return result;
}

//  A && fpf_Int
template <class TYPE>
int operator && (TYPE val, fpf_Int &right)
{
    int result;

    if( right.i_flag == 0 ){
        result = val && right.ival;
    } else {
        result = val && right.ilval;
    }
    return result;
}

//  fpf_UInt && A
template <class TYPE>
int operator && (fpf_UInt &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
        result = left.ival && val;
    } else {
        result = left.ilval && val;
    }
    return result;
}

//  A && fpf_UInt
template <class TYPE>
int operator && (TYPE val, fpf_UInt &right)
{
    int result;

    if( right.i_flag == 0 ){
        result = val && right.ival;
    } else {
        result = val && right.ilval;
    }
    return result;
}

//
//  A || A
//
//  fpf_Fixed || A
template <class TYPE>
int operator || (fpf_Fixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval || val;
    } else {
        if( left.i_flag == 0 ){
            result = left.ival || val;
        } else {
            result = left.ilval || val;
        }
    }
    return result;
}

//  etc || fpf_Fixed
template <class TYPE>
int operator || (TYPE val, fpf_Fixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val || right.fval;
    } else {
        if( right.i_flag == 0 ){
            result = val || right.ival;
        } else {
            result = val || right.ilval;
        }
    }
    return result;
}

//  fpf_UFixed || etc
template <class TYPE>
int operator || (fpf_UFixed &left, TYPE val)
{
    int result;

    if( left.p_flag == FPF_P_FLAG_WAIT ){
        result = left.fval || val;
    } else {
        if( left.i_flag == 0 ){
            result = left.ival || val;
        } else {
            result = left.ilval || val;
        }
    }
    return result;
}

//  etc || fpf_UFixed
template <class TYPE>
int operator || (TYPE val, fpf_UFixed &right)
{
    int result;

    if( right.p_flag == FPF_P_FLAG_WAIT ){
        result = val || right.fval;
    } else {
        if( right.i_flag == 0 ){
            result = val || right.ival;
        } else {
            result = val || right.ilval;
        }
    }
    return result;
}

//  fpf_Int || A
template <class TYPE>
int operator || (fpf_Int &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
        result = left.ival || val;
    } else {
        result = left.ilval || val;
    }
    return result;
}

//  A || fpf_Int
template <class TYPE>
int operator || (TYPE val, fpf_Int &right)
{
    int result;

    if( right.i_flag == 0 ){
        result = val || right.ival;
    } else {
        result = val || right.ilval;
    }
    return result;
}

//  fpf_UInt || A
template <class TYPE>
int operator || (fpf_UInt &left, TYPE val)
{
    int result;

    if( left.i_flag == 0 ){
        result = left.ival || val;
    } else {
        result = left.ilval || val;
    }
    return result;
}

//  A || fpf_UInt
template <class TYPE>
int operator || (TYPE val, fpf_UInt &right)
{
    int result;

    if( right.i_flag == 0 ){
        result = val || right.ival;
    } else {
        result = val || right.ilval;
    }
    return result;
}

//
// ե A << B 
//

// ե fpf_Int << A
template <class TYPE>
long long operator << (fpf_Int &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        if( left.type <= FPFSIM_LONG ){
            result = (int)left.ival << val;
        } else {
            result = (long long)left.ival << val;
        }
    } else {
        if( left.type <= FPFSIM_LONG ){
            result = (int)left.ilval << val;
        } else {
            result = (long long)left.ilval << val;
        }
    }
    return result;
}

// ե A << fpf_Int
template <class TYPE>
long long operator << (TYPE val, fpf_Int &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = val << right.ival;
    } else {
        result = val << right.ilval;
    }
    return result;
}

// ե fpf_UInt << A
template <class TYPE>
long long operator << (fpf_UInt &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        if( left.type <= FPFSIM_LONG ){
            result = (unsigned int)left.ival << val;
        } else {
            result = (unsigned long long)left.ival << val;
        }
    } else {
        if( left.type <= FPFSIM_LONG ){
            result = (unsigned int)left.ilval << val;
        } else {
            result = (unsigned long long)left.ilval << val;
        }
    }
    return result;
}

// ե A << fpf_UInt
template <class TYPE>
long long operator << (TYPE val, fpf_UInt &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = val << right.ival;
    } else {
        result = val << right.ilval;
    }
    return result;
}

//
// ե A >> B 
//

// ե fpf_Int >> A
template <class TYPE>
fpf_Int operator >> (fpf_Int &left, TYPE val)
{
    fpf_Int result;
    result.copy( left );

    if( left.i_flag == 0 ){
        if( left.type <= FPFSIM_LONG ){
            result.ival = (int)left.ival >> val;
        } else {
            result.ival = (long long)left.ival >> val;
        }
    } else {
        if( left.type <= FPFSIM_LONG ){
            result.ilval = (int)left.ilval >> val;
        } else {
            result.ilval = (long long)left.ilval >> val;
        }
    }
    return result;
}

// ե A >> fpf_Int
template <class TYPE>
long long operator >> (TYPE val, fpf_Int &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = val >> right.ival;
    } else {
        result = val >> right.ilval;
    }
    return result;
}

// ե fpf_UInt >> A
template <class TYPE>
fpf_UInt operator >> (fpf_UInt &left, TYPE val)
{
    fpf_UInt result;
    result.copy( left );

    if( left.i_flag == 0 ){
        if( left.type <= FPFSIM_LONG ){
            result.ival = (unsigned int)left.ival >> val;
        } else {
            result.ival = (unsigned long long)left.ival >> val;
        }
    } else {
        if( left.type <= FPFSIM_LONG ){
            result.ilval = (unsigned int)left.ilval >> val;
        } else {
            result.ilval = (unsigned long long)left.ilval >> val;
        }
    }
    return result;
}

// ե A >> fpf_UInt
template <class TYPE>
long long operator >> (TYPE val, fpf_UInt &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = val >> right.ival;
    } else {
        result = val >> right.ilval;
    }
    return result;
}

//
// ӥåXOR A ^ B 
//

// ӥåXOR fpf_Int ^ A
template <class TYPE>
long long operator ^ (fpf_Int &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        result = (long long)left.ival ^ val;
    } else {
        result = (long long)left.ilval ^ val;
    }
    return result;
}

// ӥåXOR A ^ fpf_Int
template <class TYPE>
long long operator ^ (TYPE val, fpf_Int &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = (long long)val ^ right.ival;
    } else {
        result = (long long)val ^ right.ilval;
    }
    return result;
}

// ӥåXOR fpf_UInt ^ A
template <class TYPE>
long long operator ^ (fpf_UInt &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        result = (long long)left.ival ^ val;
    } else {
        result = (long long)left.ilval ^ val;
    }
    return result;
}

// ӥåXOR A ^ fpf_UInt
template <class TYPE>
long long operator ^ (TYPE val, fpf_UInt &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = (long long)val ^ right.ival;
    } else {
        result = (long long)val ^ right.ilval;
    }
    return result;
}

//
// ӥåAND A & B 
//

// ӥåAND fpf_Int & A
template <class TYPE>
long long operator & (fpf_Int &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        result = (long long)left.ival & val;
    } else {
        result = (long long)left.ilval & val;
    }
    return result;
}

// ӥåAND A & fpf_Int
template <class TYPE>
long long operator & (TYPE val, fpf_Int &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = (long long)val & right.ival;
    } else {
        result = (long long)val & right.ilval;
    }
    return result;
}

// ӥåAND fpf_UInt & A
template <class TYPE>
long long operator & (fpf_UInt &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        result = (long long)left.ival & val;
    } else {
        result = (long long)left.ilval & val;
    }
    return result;
}

// ӥåAND A & fpf_UInt
template <class TYPE>
long long operator & (TYPE val, fpf_UInt &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = (long long)val & right.ival;
    } else {
        result = (long long)val & right.ilval;
    }
    return result;
}

//
// ӥåOR A | B 
//

// ӥåOR fpf_Int | A
template <class TYPE>
long long operator | (fpf_Int &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        result = (long long)left.ival | val;
    } else {
        result = (long long)left.ilval | val;
    }
    return result;
}

// ӥåOR A | fpf_Int
template <class TYPE>
long long operator | (TYPE val, fpf_Int &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = (long long)val | right.ival;
    } else {
        result = (long long)val | right.ilval;
    }
    return result;
}

// ӥåOR fpf_UInt | A
template <class TYPE>
long long operator | (fpf_UInt &left, TYPE val)
{
    long long result;

    if( left.i_flag == 0 ){
        result = (long long)left.ival | val;
    } else {
        result = (long long)left.ilval | val;
    }
    return result;
}

// ӥåOR A | fpf_UInt
template <class TYPE>
long long operator | (TYPE val, fpf_UInt &right)
{
    long long result;

    if( right.i_flag == 0 ){
        result = (long long)val | right.ival;
    } else {
        result = (long long)val | right.ilval;
    }
    return result;
}



#endif


